//This is a demo. DO NOT use this as a reference for how to
//use this library. There's a readme file for that.
mob
	var/AES/aes = new()
	var/cipher_text
	verb
		Encrypt_Data()
			#if INPUT_MODE == 0
			var/data = input(src, "Input text to encrypt", "Encryption") as text
			var/key = input(src, "Input a 16 character key", "Encryption") as text
			var/iv = input(src, "Input a 16 character initialization vector", "Encryption") as text
			#else
			var/data = input(src, "Input hexadecimal string to encrypt", "Encryption") as text
			var/key = input(src, "Input a 128 bit hexadecimal key", "Encryption") as text
			var/iv = input(src, "Input a 128 bit hexadecimal initialization vector", "Encryption") as text
			#endif
			world << "Encrypting"
			data = aes.Encrypt(iv, data, key)
			if(!data || istype(data, /AES_Error))
				world << "Encryption Failed"
				return
			world << "Encryption Complete"
			var/out = ""
			#if INPUT_MODE == 0
			for(var/i = 1 to length(data))
				for(var/j = 1; j <= 4; j++)
					out += "[data[i][j]] "
				out += "\n"
			#else
			out = data
			#endif
			world << "Cipher-text:\n[out]"
			cipher_text = data
		Decrypt_Data()
			#if INPUT_MODE == 0
			var/key = input(src, "Input your 16 character key", "Encryption") as text
			var/iv = input(src, "Input your 16 character initialization vector", "Encryption") as text
			#else
			var/key = input(src, "Input your 128 bit hexadecimal key", "Encryption") as text
			var/iv = input(src, "Input your 128 bit hexadecimal initialization vector", "Encryption") as text
			#endif
			if(!cipher_text)
				world << "Encrypt something first!"
				return
			world << "Decrypting"
			var/data = aes.Decrypt(iv, cipher_text, key)
			if(!data || istype(data, /AES_Error))
				world << "Decryption Failed"
				return
			world << "Decryption Complete"
			world << "Plain-text: [data]"
		#if INPUT_MODE == 1
		Test_Vectors()
			world << "TEST VECTORS FOUND AT http://www.inconteam.com/software-development/41-encryption/55-aes-test-vectors"
			var/key = "2b7e151628aed2a6abf7158809cf4f3c"
			var/list/iv = list("000102030405060708090A0B0C0D0E0F",
				"7649ABAC8119B246CEE98E9B12E9197D",
				"5086CB9B507219EE95DB113A917678B2",
				"73BED6B8E3C1743B7116E69E22229516")
			var/list/data = list("6bc1bee22e409f96e93d7e117393172a",
				"ae2d8a571e03ac9c9eb76fac45af8e51",
				"30c81c46a35ce411e5fbc1191a0a52ef",
				"f69f2445df4f9b17ad2b417be66c3710")
			world << "Key: [key]\n"
			for(var/i = 1; i <= 4; i++)
				world << "Test Vector: [data[i]]"
				world << "IV: [iv[i]]"
				data[i] = aes.Encrypt(iv[i],data[i],key)
				world << "Encrypted Vector: [data[i]]"
				data[i] = aes.Decrypt(iv[i], data[i], key)
				world << "Decrypted Vector: [data[i]]\n"
		#endif